// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: hibernate/HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.adagio.core.dao.referential.conversion;

import fr.ifremer.adagio.core.dao.referential.location.Location;
import fr.ifremer.adagio.core.dao.referential.pmfm.QualitativeValue;
import fr.ifremer.adagio.core.dao.referential.taxon.TaxonGroup;
import java.io.Serializable;
import java.sql.Timestamp;
import java.util.Date;

/**
 * <html>
 * <head>
 * </head>
 * <body>
 * <p>
 * <b>Equivalent poids vif </b>:<br><br>
 * </p>
 * <p>
 * Le calcul se fait par multiplication du poids total du lot par un
 * coefficient multiplicateur (convCoeff) . Ce coefficient est obtenu &#224;
 * partir des caract&#233;ristiques suivantes :<br>- esp&#232;ce commerciale :
 * TaxonGroup<br>- pr&#233;sentation du poisson: fishPresentation (ex :
 * &quot;Entier&quot;, &quot;Vid&#233;&quot;, &quot;&#201;t&#234;t&#233;, vid&#233;,
 * &#233;queut&#233;&quot;, &quot;D&#233;cortiqu&#233;&quot;, ...).<br>-
 * Etat du poisson : fishState (ex : &quot;frais&quot;, &quot;congel&#233;&quot;,
 * &quot;sal&#233;&quot;,
 * &quot;s&#233;ch&#233;&quot;...).<br>- Pays dans lequel s&#8217;est effectu&#233;e
 * la capture.
 * </p>
 * <p>
 * <u>Definition FAO :</u> &quot;Round Weigth&quot; : the weight of the whole fish
 * before processing or removal of any part.<br>FAO (1998): Guidelines for
 * the routine collection of capture fishery data. FAO Fish. Tech. Pap,
 * 382: 113 p.
 * </p>
 * </body>
 * </html>
 */
// HibernateEntity.vsl annotations merge-point
public abstract class RoundWeightConversion
    implements Serializable, Comparable<RoundWeightConversion>
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = -2235925763984374257L;

    // Generate 6 attributes
    private Integer id;

    /**
     * Idenfiant interne. Généré par le système.
     * @return this.id Integer
     */
    public Integer getId()
    {
        return this.id;
    }

    /**
     * Idenfiant interne. Généré par le système.
     * @param idIn Integer
     */
    public void setId(Integer idIn)
    {
        this.id = idIn;
    }

    private Float conversionCoefficient;

    /**
     * Coefficient de conversion pour l'équivalent poids vif.
     * @return this.conversionCoefficient Float
     */
    public Float getConversionCoefficient()
    {
        return this.conversionCoefficient;
    }

    /**
     * Coefficient de conversion pour l'équivalent poids vif.
     * @param conversionCoefficientIn Float
     */
    public void setConversionCoefficient(Float conversionCoefficientIn)
    {
        this.conversionCoefficient = conversionCoefficientIn;
    }

    private Date startDate;

    /**
     * 
     * @return this.startDate Date
     */
    public Date getStartDate()
    {
        return this.startDate;
    }

    /**
     * 
     * @param startDateIn Date
     */
    public void setStartDate(Date startDateIn)
    {
        this.startDate = startDateIn;
    }

    private Date endDate;

    /**
     * 
     * @return this.endDate Date
     */
    public Date getEndDate()
    {
        return this.endDate;
    }

    /**
     * 
     * @param endDateIn Date
     */
    public void setEndDate(Date endDateIn)
    {
        this.endDate = endDateIn;
    }

    private String description;

    /**
     * 
     * @return this.description String
     */
    public String getDescription()
    {
        return this.description;
    }

    /**
     * 
     * @param descriptionIn String
     */
    public void setDescription(String descriptionIn)
    {
        this.description = descriptionIn;
    }

    private Timestamp updateDate;

    /**
     * 
     * @return this.updateDate Timestamp
     */
    public Timestamp getUpdateDate()
    {
        return this.updateDate;
    }

    /**
     * 
     * @param updateDateIn Timestamp
     */
    public void setUpdateDate(Timestamp updateDateIn)
    {
        this.updateDate = updateDateIn;
    }

    // Generate 4 associations
    private Location location;

    /**
     * Représente un lieu au sens général du terme. Il peut s'agir d'un lieu ponctuel, linéaire ou
     * surfacique.
     * Suivant sa classification et son niveau, il peut s'agir d'un secteur FAO, un port de pêche,
     * un
     * quartier maritime, une criée, etc.
     * Nombre de lignes : lieux terrestre : 4500 + secteurs : 11210 + strates : 1000 + localités :
     * 200
     * @return this.location Location
     */
    public Location getLocation()
    {
        return this.location;
    }

    /**
     * Représente un lieu au sens général du terme. Il peut s'agir d'un lieu ponctuel, linéaire ou
     * surfacique.
     * Suivant sa classification et son niveau, il peut s'agir d'un secteur FAO, un port de pêche,
     * un
     * quartier maritime, une criée, etc.
     * Nombre de lignes : lieux terrestre : 4500 + secteurs : 11210 + strates : 1000 + localités :
     * 200
     * @param locationIn Location
     */
    public void setLocation(Location locationIn)
    {
        this.location = locationIn;
    }

    private QualitativeValue preserving;

    /**
     * Etat du poisson (entier, Eteté, etc.)
     * @return this.preserving QualitativeValue
     */
    public QualitativeValue getPreserving()
    {
        return this.preserving;
    }

    /**
     * Etat du poisson (entier, Eteté, etc.)
     * @param preservingIn QualitativeValue
     */
    public void setPreserving(QualitativeValue preservingIn)
    {
        this.preserving = preservingIn;
    }

    private QualitativeValue dressing;

    /**
     * Présentation du poisson (Frais, Congelé, ...)
     * @return this.dressing QualitativeValue
     */
    public QualitativeValue getDressing()
    {
        return this.dressing;
    }

    /**
     * Présentation du poisson (Frais, Congelé, ...)
     * @param dressingIn QualitativeValue
     */
    public void setDressing(QualitativeValue dressingIn)
    {
        this.dressing = dressingIn;
    }

    private TaxonGroup taxonGroup;

    /**
     * Il désigne un ensemble de taxons appartenant à des groupes taxinomiques différents mais ayant
     * les
     * mêmes caractéristiques pour un critère donné. Ce critère peut être morpho-anatomique (par
     * exemple
     * les strates algales ou la taille des organismes), comportemental (par exemple des groupes
     * trophiques
     * ou des modes de déplacement), ou encore basé sur des notions plus complexes comme la
     * polluo-sensibilité (exemple des groupes écologiques définis pour les macroinvertébrés
     * benthiques).
     * Pour un critère donné, les groupes de taxons sont rassemblés dans un regroupement appelé
     * groupe de
     * taxons père.
     * Les groupes de taxons sont de deux catégories :
     * - Descriptif : c'est à dire seulement utilisé pour l'extraction de données. Les regroupements
     * de
     * taxons sont effectués en aval de la mesure effectuée.
     * - Identification : il s'agit de regroupements utilisés pour identifier des catégories de
     * taxons sur
     * le terrain ou en laboratoire, lorsqu'il est difficile d'opérer une identification précise ou
     * lorsque
     * celle-ci s'avère tout simplement impossible ou non pertinente. Le regroupement des taxons
     * s'effectue
     * alors en amont de la mesure.
     * Certains groupes peuvent être figés, c'est à dire qu'ils sont définis une bonne fois pour
     * toute dans
     * un document. Pour ce dernier cas particulier, il n'y a donc, a priori, pas besoin de mise à
     * jour, et
     * encore moins de pouvoir les supprimer : ils sont donc non modifiables (mais ce ne doit pas
     * être une
     * règle générale)
     * @return this.taxonGroup TaxonGroup
     */
    public TaxonGroup getTaxonGroup()
    {
        return this.taxonGroup;
    }

    /**
     * Il désigne un ensemble de taxons appartenant à des groupes taxinomiques différents mais ayant
     * les
     * mêmes caractéristiques pour un critère donné. Ce critère peut être morpho-anatomique (par
     * exemple
     * les strates algales ou la taille des organismes), comportemental (par exemple des groupes
     * trophiques
     * ou des modes de déplacement), ou encore basé sur des notions plus complexes comme la
     * polluo-sensibilité (exemple des groupes écologiques définis pour les macroinvertébrés
     * benthiques).
     * Pour un critère donné, les groupes de taxons sont rassemblés dans un regroupement appelé
     * groupe de
     * taxons père.
     * Les groupes de taxons sont de deux catégories :
     * - Descriptif : c'est à dire seulement utilisé pour l'extraction de données. Les regroupements
     * de
     * taxons sont effectués en aval de la mesure effectuée.
     * - Identification : il s'agit de regroupements utilisés pour identifier des catégories de
     * taxons sur
     * le terrain ou en laboratoire, lorsqu'il est difficile d'opérer une identification précise ou
     * lorsque
     * celle-ci s'avère tout simplement impossible ou non pertinente. Le regroupement des taxons
     * s'effectue
     * alors en amont de la mesure.
     * Certains groupes peuvent être figés, c'est à dire qu'ils sont définis une bonne fois pour
     * toute dans
     * un document. Pour ce dernier cas particulier, il n'y a donc, a priori, pas besoin de mise à
     * jour, et
     * encore moins de pouvoir les supprimer : ils sont donc non modifiables (mais ce ne doit pas
     * être une
     * règle générale)
     * @param taxonGroupIn TaxonGroup
     */
    public void setTaxonGroup(TaxonGroup taxonGroupIn)
    {
        this.taxonGroup = taxonGroupIn;
    }

    /**
     * Returns <code>true</code> if the argument is an RoundWeightConversion instance and all identifiers for this entity
     * equal the identifiers of the argument entity. Returns <code>false</code> otherwise.
     */
    @Override
    public boolean equals(Object object)
    {
        if (this == object)
        {
            return true;
        }
        if (!(object instanceof RoundWeightConversion))
        {
            return false;
        }
        final RoundWeightConversion that = (RoundWeightConversion)object;
        if (this.id == null || that.getId() == null || !this.id.equals(that.getId()))
        {
            return false;
        }
        return true;
    }

    /**
     * Returns a hash code based on this entity's identifiers.
     */
    @Override
    public int hashCode()
    {
        int hashCode = 0;
        hashCode = 29 * hashCode + (this.id == null ? 0 : this.id.hashCode());

        return hashCode;
    }

    /**
     * Constructs new instances of {@link RoundWeightConversion}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link RoundWeightConversion}.
         * @return new RoundWeightConversionImpl()
         */
        public static RoundWeightConversion newInstance()
        {
            return new RoundWeightConversionImpl();
        }

        /**
         * Constructs a new instance of {@link RoundWeightConversion}, taking all required and/or
         * read-only properties as arguments, except for identifiers.
         * @param conversionCoefficient Float
         * @param startDate Date
         * @param location Location
         * @param preserving QualitativeValue
         * @param dressing QualitativeValue
         * @param taxonGroup TaxonGroup
         * @return newInstance
         */
        public static RoundWeightConversion newInstance(Float conversionCoefficient, Date startDate, Location location, QualitativeValue preserving, QualitativeValue dressing, TaxonGroup taxonGroup)
        {
            final RoundWeightConversion entity = new RoundWeightConversionImpl();
            entity.setConversionCoefficient(conversionCoefficient);
            entity.setStartDate(startDate);
            entity.setLocation(location);
            entity.setPreserving(preserving);
            entity.setDressing(dressing);
            entity.setTaxonGroup(taxonGroup);
            return entity;
        }

        /**
         * Constructs a new instance of {@link RoundWeightConversion}, taking all possible properties
         * (except the identifier(s))as arguments.
         * @param conversionCoefficient Float
         * @param startDate Date
         * @param endDate Date
         * @param description String
         * @param updateDate Timestamp
         * @param location Location
         * @param preserving QualitativeValue
         * @param dressing QualitativeValue
         * @param taxonGroup TaxonGroup
         * @return newInstance RoundWeightConversion
         */
        public static RoundWeightConversion newInstance(Float conversionCoefficient, Date startDate, Date endDate, String description, Timestamp updateDate, Location location, QualitativeValue preserving, QualitativeValue dressing, TaxonGroup taxonGroup)
        {
            final RoundWeightConversion entity = new RoundWeightConversionImpl();
            entity.setConversionCoefficient(conversionCoefficient);
            entity.setStartDate(startDate);
            entity.setEndDate(endDate);
            entity.setDescription(description);
            entity.setUpdateDate(updateDate);
            entity.setLocation(location);
            entity.setPreserving(preserving);
            entity.setDressing(dressing);
            entity.setTaxonGroup(taxonGroup);
            return entity;
        }
    }

    /**
     * @see Comparable#compareTo
     */
    public int compareTo(RoundWeightConversion o)
    {
        int cmp = 0;
        if (this.getId() != null)
        {
            cmp = this.getId().compareTo(o.getId());
        }
        else
        {
            if (this.getConversionCoefficient() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getConversionCoefficient().compareTo(o.getConversionCoefficient()));
            }
            if (this.getStartDate() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getStartDate().compareTo(o.getStartDate()));
            }
            if (this.getEndDate() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getEndDate().compareTo(o.getEndDate()));
            }
            if (this.getDescription() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getDescription().compareTo(o.getDescription()));
            }
            if (this.getUpdateDate() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getUpdateDate().compareTo(o.getUpdateDate()));
            }
        }
        return cmp;
    }
// HibernateEntity.vsl merge-point
// RoundWeightConversion.java merge-point
}